<?php

/**
 * Description of nvmCore
 *
 * @author hampel_ma
 */
final class nvmcore implements InvmCore
{

  private $_server = NVMHOST;
  private static $_instance = null;
  private $requestform;

  private function nvmcore()
  {
    
  }

  public static function getInstance()
  {
    if (self::$_instance == null)
    {
      self::$_instance = new nvmcore();
    }
    return self::$_instance;
  }

  public function setRequestForm($_request = array())
  {
    $this->requestform = $_request;
  }

  public function saveValue()
  {
    return $this->sendRequest();
  }

  public function getOneValue($_value)
  {
    $this->requestform = array('method' => 'getV', 'param' => $_value, 'field' => 'webui');
    return $this->sendRequest();
  }

  public function getAllValue()
  {

    $this->requestform = array('method' => 'getColsL', 'param' => '%', 'field' => 'webui', 'fields' => 'value,webui,flags,regexp,enum,range_min,range_max');
    return $this->sendRequest();
  }

  public function makeRequest()
  {
    return $this->sendRequest();
  }

  private function sendRequest()
  {
    try
    {


      $consocket = $this->ConnectService();
      $stringtab = str_split(json_encode($this->requestform), 255);
      $consocket->sendmulti($stringtab);
      $response = $consocket->recvMulti();
      return $response;
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  private function sendRequestMessage($_topic)
  {
    try
    {
      $countrequest = count($this->requestform);

      $conn = $this->_connect;
      $publisher = $conn->getSocket(ZMQ::SOCKET_PUB);
      $publisher->connect(NVMHOSTMESSAGE);

      if ($countrequest > 1)
      {
        foreach ($this->requestform as $key => $value)
        {
          $publisher->send($_topic . json_encode($value), ZMQ::MODE_NOBLOCK);
        }
      }
      else
        $publisher->send($_topic . json_encode($value), ZMQ::MODE_NOBLOCK);
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);
      return false;
    }
  }

  public function makeMessageRequest($_topic)
  {
    $this->sendRequestMessage($_topic);
  }

  public function connectService()
  {
    try
    {

      $this->_connect = new ZMQContext();
      $socket = $this->_connect->getSocket(ZMQ::SOCKET_REQ);
      return $socket->connect($this->_server);
    }
    catch (Exception $ex)
    {
      $exc = new errorexceptionhandler();
      $exc->getException($ex);

      return false;
    }
  }

}
